<template>
  <ObForm
    :form-data="formData"
    :ok-text="okButtonText"
    @submit="onSubmit"
    data-qa="tenderBuyerAddQuestionnaireForm"
  >
    <ObInput
      placeholder="Введите ключевое слово"
      class="search"
      icon="search"
      @input="onSearchInput"
    />

    <ObTable
      ref="questionsTable"
      :items="questions"
      :columns="columns"
      :show-add-button="false"
      :with-checkboxes="true"
      :page-limit="questions.length"
      :is-groups-opened="false"
      :search-query="searchQuery"
      :checked-rows="initialSelectedUuids"
      :static-groups="staticGroups"
      class="questions-table"
      group-by="group"
      data-qa="tenderBuyerAddQuestionnaireTable"
      @row-toggle="onToggle"
      @group-toggle="onToggle"
    />
  </ObForm>
</template>

<script>
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObInput from 'common-components/src/obComponents/obInput'

  import { mapGetters } from 'vuex'

  export default {
    name: 'add-questionnaire',
    components: {
      ObTable,
      ObForm,
      ObInput
    },
    props: {
      questions: {
        type: Array,
        required: true
      },
      staticGroups: {
        type: Array,
        default: () => []
      },
      isUserQuestionsEnabled: {
        type: Boolean,
        default: false
      },
      modalState: {
        type: Boolean,
        default: false
      }
    },
    data () {
      return {
        searchQuery: null,
        selectedUuids: [],
        initialSelectedUuids: [],
        columns: [
          {
            key: 'title',
            sortDisable: true,
            title: 'Раздел или вопрос',
            exactWidth: '64%'
          },
          {
            key: 'typeReadable',
            sortDisable: true,
            title: 'Тип вопроса',
            exactWidth: '36%'
          }
        ]
      }
    },
    computed: {
      ...mapGetters({
        tenderInfo: 'tenders/tenderInfo'
      }),
      formData ({ data = {} }) {
        // Using form data to control submit button:
        // enable submit button only if selected rows list was changed
        this.selectedUuids.map(uuid => data[uuid] = true)

        return data
      },
      okButtonText () {
        if (this.selectedUuids.length) {
          return `Добавить ${this.plural(this.selectedUuids.length, ' вопрос | вопроса | вопросов')}`
        } else {
          return 'Сохранить'
        }
      }
    },
    mounted () {
      this.initialize()
    },
    watch: {
      // Checking modal window state to reinitialize
      // selected uuids info with the fresh questions data,
      // due to user questions group
      modalState (isVisible) {
        if (isVisible) {
          this.initialize()
        }
      }
    },
    methods: {
      initialize () {
        // Reset array to clear previous init data
        this.initialSelectedUuids = []

        this.questions.forEach((question) => {
          if (
            question.isSelected ||
            // If user checked user questions group, but doesn't added any question
            (question.isUserQuestionsAvailable && this.isUserQuestionsEnabled)
          ) {
            this.initialSelectedUuids.push(question.uuid)
          }
        })

        // Initial selected uuids array using for :checked-rows prop,
        // selected uuids array using to calc form data
        this.selectedUuids = this.initialSelectedUuids
      },
      onSubmit () {
        const isUserQuestionsEnabled = this.questions.find((item) => {
          return (item.isUserQuestionsAvailable || item.isUserQuestion) && this.formData[item.uuid]
        })

        this.$emit('add', this.selectedUuids, Boolean(isUserQuestionsEnabled))
      },
      onToggle (data, selectedUuids) {
        this.selectedUuids = selectedUuids
      },
      onSearchInput (query) {
        this.searchQuery = query
      },
      plural (value, unit) {
        return value + this.declOfNum(value, unit)
      },
      declOfNum (n, string) {
        let titles = string.split('|')

        return titles[
          n % 10 === 1 && n % 100 !== 11
            ? 0
            : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20)
            ? 1
            : 2
        ]
      }
    }
  }
</script>

<style lang="scss" scoped>
  .search {
    margin-bottom: 20px;

    &::v-deep .icon {
      color: $color-grey-span;
    }
  }

  .questions-table {
    border: 1px solid $lavender;
    border-top: 0;
  }
</style>